void PLL_Config(void)
{
  RCC_PeriphCLKInitTypeDef PeriphClkInitStruct = {  0};
  
  PeriphClkInitStruct.PeriphClockSelection = RCC_PERIPHCLK_I2S_APB1;
/*
  PeriphClkInitStruct.I2sApb1ClockSelection = RCC_I2SAPB1CLKSOURCE_PLLR;  
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
*/
  PeriphClkInitStruct.PeriphClockSelection  = RCC_PERIPHCLK_I2S_APB1;
  PeriphClkInitStruct.PLLI2S.PLLI2SN        = 196;
  PeriphClkInitStruct.PLLI2S.PLLI2SP        = RCC_PLLI2SP_DIV2;
  PeriphClkInitStruct.PLLI2S.PLLI2SM        = 4;
  PeriphClkInitStruct.PLLI2S.PLLI2SR        = 2;
  PeriphClkInitStruct.PLLI2S.PLLI2SQ        = 2;
  PeriphClkInitStruct.PLLI2SDivQ            = 1;
  PeriphClkInitStruct.I2sApb1ClockSelection = RCC_I2SAPB1CLKSOURCE_PLLI2S;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct) != HAL_OK)
  {
    Error_Handler();
  }  
}

void I2S2_DMA_Init(void) 
{
  __HAL_RCC_DMA1_CLK_ENABLE();

  HAL_NVIC_SetPriority(DMA1_Stream4_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Stream4_IRQn);
}

void I2S_I2S2_Init(void)
{
  //Reg: 4000381C  Value:  0000 0000    0000 0000    0000 1100    0000 0001      (0x00000C01)
  // Clock divider [7:0]; ODD bit [8:]
  //Reg: 40003820  Value:  0000 0000    0000 0000    0000 0010    0000 0010      (0x00000202)

  hi2s2.Instance            = SPI2;
  hi2s2.Init.Mode           = I2S_MODE_MASTER_TX;
  hi2s2.Init.Standard       = I2S_STANDARD_PHILIPS;
  hi2s2.Init.DataFormat     = I2S_DATAFORMAT_24B;
  
  //  hi2s2.Init.AudioFreq      = I2S_AUDIOFREQ_48K;
  hi2s2.Init.AudioFreq      = I2S_AUDIOFREQ_96K;
  //  hi2s2.Init.AudioFreq      = I2S_AUDIOFREQ_192K;
  
  hi2s2.Init.MCLKOutput     = I2S_MCLKOUTPUT_ENABLE;
  hi2s2.Init.CPOL           = I2S_CPOL_LOW;
  hi2s2.Init.ClockSource    = I2S_CLOCK_PLL;
  hi2s2.Init.FullDuplexMode = I2S_FULLDUPLEXMODE_DISABLE;
  if (HAL_I2S_Init(&hi2s2) != HAL_OK)
  {
    Error_Handler();
  }
}

void HAL_I2S_MspInit(I2S_HandleTypeDef* hi2s)
{
  GPIO_InitTypeDef GPIO_InitStruct = { 0};

  if(hi2s->Instance == SPI2) {
    __HAL_RCC_SPI2_CLK_ENABLE();  
    __HAL_RCC_GPIOB_CLK_ENABLE();
    __HAL_RCC_GPIOC_CLK_ENABLE();

    /**I2S2 GPIO Configuration    
    PB12     ------> I2S2_WS
    PB13     ------> I2S2_CK
    PB15     ------> I2S2_SD 
    PC6     ------> I2S2_MCK 
    */
    GPIO_InitStruct.Pin       = GPIO_PIN_12|GPIO_PIN_13|GPIO_PIN_15;
    GPIO_InitStruct.Mode      = GPIO_MODE_AF_PP;
    GPIO_InitStruct.Pull      = GPIO_NOPULL;
    //  GPIO_InitStruct.Speed     = GPIO_SPEED_FREQ_VERY_HIGH;
    GPIO_InitStruct.Speed     = GPIO_SPEED_FREQ_LOW;
    GPIO_InitStruct.Alternate = GPIO_AF5_SPI2;
    HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

    GPIO_InitStruct.Pin       = GPIO_PIN_6;
    GPIO_InitStruct.Speed     = GPIO_SPEED_FREQ_VERY_HIGH;
    HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

    hdma_spi2_tx.Instance                 = DMA1_Stream4;
    hdma_spi2_tx.Init.Channel             = DMA_CHANNEL_0;
    hdma_spi2_tx.Init.Direction           = DMA_MEMORY_TO_PERIPH;
    hdma_spi2_tx.Init.PeriphInc           = DMA_PINC_DISABLE;
    hdma_spi2_tx.Init.MemInc              = DMA_MINC_ENABLE;
    //    hdma_spi2_tx.Init.PeriphDataAlignment = DMA_PDATAALIGN_WORD;
    //  hdma_spi2_tx.Init.MemDataAlignment    = DMA_MDATAALIGN_WORD;
    hdma_spi2_tx.Init.PeriphDataAlignment = DMA_PDATAALIGN_HALFWORD;
    hdma_spi2_tx.Init.MemDataAlignment    = DMA_MDATAALIGN_HALFWORD;
    hdma_spi2_tx.Init.Mode                = DMA_CIRCULAR;
//    hdma_spi2_tx.Init.Priority            = DMA_PRIORITY_VERY_HIGH;
    hdma_spi2_tx.Init.Priority            = DMA_PRIORITY_MEDIUM;
    hdma_spi2_tx.Init.FIFOMode            = DMA_FIFOMODE_DISABLE;

    __HAL_LINKDMA( hi2s, hdmatx, hdma_spi2_tx);

    if (HAL_DMA_Init(&hdma_spi2_tx) != HAL_OK)
    {
      Error_Handler();
    }
  }
}



//**//
