/*   I2S-2 (SPI-2):Tx -> : pcm1798

 Esli ne kompiliryetsya:
  1.  v variant.h dobavit'   #define HAL_I2S_MODULE_ENABLED  
  2.  ~.arduino15/packages/STM32/hardware/stm32/1.9.0/libraries/SrcWrapper/src/HAL/
      sozdat' (esli ego tam net) stm32yyxx_hal_i2s.c 
  
    PB12 - D16 (CN10 - right side, close to D11). NSS
    PB13 - D30 (CN10 - right side, close to D4).  SCK
    PB15 - D26 (CN10 - right side, close to D6).  MOSI 
    Reg: 4000381C Value:  0000 0000    0000 0000    0000 1110    0000 0011      (0x00000E03)
    Reg: 40003820 Value:  0000 0000    0000 0000    0000 0010    0000 0100      (0x00000204)

    PC6     ------> I2S2_MCK 
            
    DEBUG D10, 11, 12, 13
          B6,  A7, A6, A5
*/

/* TO DO

*/


          I2S_HandleTypeDef                   hi2s2;
          DMA_HandleTypeDef            hdma_spi2_tx;
          
#define   DAC_SIZE                ((uint32_t)  2048)   

#define   RAD_ANGL              180.0 / 3.141592654
#define   ANGL_RAD              3.141592654 / 180.0
#define   PIXS_RAD           ((double) 2048 / 360.0)

        
volatile  int16_t         flag_updt         =     0; // update sine-wave table for Dac

          uint16_t        out[4 *DAC_SIZE]  =  { 0}; // 16k  
          float           waves1[DAC_SIZE]   = {0.0}; // 8k
          float           waves2[DAC_SIZE]   = {0.0}; // 8k

          String          in_String         =   " ";        
          boolean         end_input         = false;  
          uint8_t         debug_osm         =     0;

          uint32_t        adres_reg    = 0x4000002c;         
          uint32_t        field_bit         =     0;
          uint32_t        field_len         =    16;

          uint16_t        dac_freq1         =   43;       // 46.875 Hz/ na Bin          
          uint16_t        dac_freq2         =   43;       // 46.875 Hz/ na Bin          
          uint16_t        har_numbr         =     1;          

          float        magnt_set1[16] =  { 0.0, 30000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; 
          float        phase_set1[16] =  { 0.0,     0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; 

          float        magnt_set2[16] =  { 0.0, 30000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; 
          float        phase_set2[16] =  { 0.0,     0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; 

          uint16_t        dc_output         =     0;  
          uint16_t        left_rigt         =     0;  

void setup()
{
  Serial.begin(115200);
  in_String.reserve(200);

  Serial.print(F("\n\tSketch: pcm1798_i2s2_6b   22-Feb-2022"));

  Serial.print(F("\n\tSys_clock: "));
  Serial.print(((uint32_t) SystemCoreClock /(float) 1000000.0), 1);
  Serial.print(F(" MHz."));

  Serial.print(F("\n\tcfg_Pins..."));
  delay(100);      
  cfg_Pins1();
  Serial.print(F("\tdone."));
  
  Serial.print(F("\n\tPll config..."));
  delay(100);
  PLL_Config();
  Serial.print(F("\tdone."));

  Serial.print(F("\n\ti2s2_dma_init..."));
  delay(100);
  I2S2_DMA_Init();
  Serial.print(F("\tdone."));

  Serial.print(F("\n\ti2s_i2s2_init..."));
  delay(100);
  I2S_I2S2_Init();
  Serial.print(F("\tdone."));

  Serial.print(F("\n\thal_i2s_trasmit_dma..."));
  delay(100);
  //  HAL_I2S_Transmit_DMA( &hi2s2, (uint32_t *)out[0], INP_BUFF); 
  HAL_I2S_Transmit_DMA( &hi2s2, (uint16_t *) out, (2 *DAC_SIZE)); 
  Serial.print(F("\tdone."));

/*
  HAL_I2S_DMAPause( &hi2s2);
  Serial.print(F("\n\tchange clock to 250 ksps..."));
  delay(100);
  (*(uint32_t*)0x40003820) = 0x0000000C; // 192.0 / (32 * div * 2)
                                         
  HAL_I2S_DMAResume( &hi2s2);
*/

  generator();
/*  
  HAL_I2S_DMAPause( &hi2s2);
  Serial.print(F("\n\tchange i2s-2 clock to 250 ksps..."));
  delay(100);
  (*(uint32_t*)0x40003820) = 0x0000000C; 
// fS = I2SxCLK / [(32*2)*((2*I2SDIV)+ODD)*4)] 
// when the channel frame is 32-bit wide
  HAL_I2S_DMAResume( &hi2s2);
// 2 na 192 ksps, 
// 4 na 96 ksps  
// 10 0000 0100 MSC-ODD-DIVI2S mo-dddd-dddd
*/
  Serial.print(F("\n\tSetup done."));
}

void loop()  
{
  char *    pEnd;
  uint32_t  temp  =   0;
  float     tempf = 0.0;  

// d, a, r, w - (a)ddress variable length.
// u, b, l - d(u)mp, (b)it start, (l)enght of the bit field.

// x, c - stop & continue dac-dma

// f - generator
// n - harmonic's number
// p - phase
// m - magn.
// g, h - print sine
// o - DC
// k - kanal levui-pravui

/*  
  q, *w,  e, *r,  t,  y, *u,  i, *o, *p, 
 *a,  s, *d, *f, *g, *h,  j, *k, *l, 
  z, *x, *c,  v, *b, *n, *m,    
*/

  serialEvent(); 

  if( end_input) {
    char cmd = in_String[0];
    in_String[0] = '+';

    if( cmd == 'k' ) {
      left_rigt = strtol( in_String.c_str(), &pEnd, 10);
      left_rigt &= 0x01;
      if(left_rigt == 0) {
        Serial.print(F("\nChannel Left."));
        }
      else {       
        Serial.print(F("\nChannel Right."));
        }
      }

    if( cmd == 'o' ) {
      dc_output = 1 - dc_output;
      generator();
      if(dc_output) Serial.print(F("\ndc_output aktiv."));
      else          Serial.print(F("\ndc_output de-aktiv."));
      }
    if( cmd == 'g') {
      prnt_out(waves1, DAC_SIZE, 1, 16777216.0); //65536.0);
      prnt_out(waves2, DAC_SIZE, 1, 16777216.0); //65536.0);
      }
    if( cmd == 'h') {
      Serial.print("\n\t Left \n\t");      
      for( uint32_t i = 0; i < (4*DAC_SIZE); i += 4) {
        Serial.print(out[i]);       
        Serial.print("\t");    
        Serial.print(out[i+1]);       
        Serial.print("\t");    
        if ((i+4)%32 == 0) Serial.print("\n\t");
        }
      Serial.println("\n\t");

      Serial.print("\n\t Right \n\t");      
      for( uint32_t i = 2; i < (4*DAC_SIZE); i += 4) {
        Serial.print(out[i]);       
        Serial.print("\t");    
        Serial.print(out[i+1]);       
        Serial.print("\t");    
        if ((i+2)%32 == 0) Serial.print("\n\t");
        }
      Serial.println("\n\t");
      }

    if( cmd == 'n' ) {
      har_numbr = strtol( in_String.c_str(), &pEnd, 10);
      if(har_numbr > 7)  har_numbr = 7;
      if(har_numbr < 1)  har_numbr = 1;
      Serial.print(F("\n\tHarmonic is set: "));
      Serial.print(har_numbr, DEC);
      }      
    if( cmd == 'f' ) {
      // dac_freq1 = strtol( in_String.c_str(), &pEnd, 10);
      temp = strtol( in_String.c_str(), &pEnd, 10);
      if(left_rigt == 0) dac_freq1 = temp; 
      if(left_rigt == 1) dac_freq2 = temp; 
      generator();
      Serial.print(F("\n\tFrequency is set, Left: "));
      Serial.print(dac_freq1, DEC);
      Serial.print(F("\t, Right: "));
      Serial.print(dac_freq2, DEC);
      }      
    if( cmd == 'm' ) {
      tempf = strtol( in_String.c_str(), &pEnd, 10);
      // magnt_set[har_numbr] = tempf /100.0;
      if(left_rigt == 0) magnt_set1[har_numbr] = tempf /100.0;
      if(left_rigt == 1) magnt_set2[har_numbr] = tempf /100.0;
      Serial.print(F("\n\tmagnt_set["));
      Serial.print(har_numbr, DEC);
      Serial.print(F("] Left = "));
      Serial.print(magnt_set1[har_numbr], 2);
      Serial.print(F("\t Right = "));
      Serial.print(magnt_set2[har_numbr], 2);
      generator();
      }      
    if( cmd == 'p' ) {
      tempf = strtol( in_String.c_str(), &pEnd, 10);
      // phase_set1[har_numbr] = tempf;
      if(left_rigt == 0) phase_set1[har_numbr] = tempf;
      if(left_rigt == 1) phase_set2[har_numbr] = tempf;
      Serial.print(F("\n\tphase_set["));
      Serial.print(har_numbr, DEC);
      Serial.print(F("] Left = "));
      Serial.print(phase_set1[har_numbr], 2);
      Serial.print(F("\t Right = "));
      Serial.print(phase_set2[har_numbr], 2);
      generator();
      }      

    if( cmd == 'x' ) {
      Serial.print(F("\n\tDac stop."));
      HAL_I2S_DMAPause( &hi2s2);
      }
    if( cmd == 'c' ) {
      Serial.print(F("\n\tDac start."));
      HAL_I2S_DMAResume( &hi2s2);
      }

    if( cmd == 'd' ) {
      debug_osm = strtol( in_String.c_str(), &pEnd, 10);
      if(debug_osm) {
        Serial.print(F("\nDebug N: "));
        Serial.print(debug_osm, DEC);                
        }
      else {       
        Serial.print(F("\nDebug de-aktiv."));
//        init_srch = 1;
        }
      }
    if( cmd == 'u' ) {
      prnt_damp();
      }                    
    if( cmd == 'b' ) {
      field_bit = strtol( in_String.c_str(), &pEnd, 10);
      if(field_bit < 32) {
        Serial.print(F("\n\tBit field starts: "));
        Serial.print(field_bit, DEC);        
        }
      else
        Serial.print(F("\n\tError."));
      }
    if( cmd == 'l' ) {
      field_len = strtol( in_String.c_str(), &pEnd, 10);
      if((field_len + field_bit) < 33) {
        Serial.print(F("\n\tBit field length: "));
        Serial.print(field_len, DEC);        
        }
      else
        Serial.print(F("\n\tError."));
      }
    if( cmd == 'a' ) {
      uint8_t dlina = in_String.length() -2;      
      temp = strtol( in_String.c_str(), &pEnd, 16);
      addr_cast(temp, dlina);      
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
    if( cmd == 'r' ) {
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
    if( cmd == 'w' ) {
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      
      temp = strtol( in_String.c_str(), &pEnd, 2);      
      set_bitf(temp);
  
//      Serial.print(F("\n\tReg: "));
      Serial.print(F("\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }

    in_String = "";
    end_input= false;
  }
}

void serialEvent() {
  while (Serial.available()) {
    char inChar = (char)Serial.read();
    in_String += inChar;
    if (inChar == '\n') {
      end_input= true;
    }
  }
}


//**//
